"{ Package: 'stx:libjava' }"

Lookup subclass:#JavaLookup
	instanceVariableNames:''
	classVariableNames:'Instance'
	poolDictionaries:''
	category:'Languages-Java-Lookup'
!


!JavaLookup class methodsFor:'instance creation'!

instance
    Instance ifNil: [
        Instance := self basicNew.
    ].
    ^ Instance.

    "Modified: / 25-02-2011 / 14:45:03 / kursjan <kursjan@fit.cvut.cz>"
!

new
    ^ self instance.

    "Created: / 25-02-2011 / 14:44:43 / kursjan <kursjan@fit.cvut.cz>"
! !

!JavaLookup methodsFor:'lookup'!

javaLookupMethodForSelector:selector for:receiver withArguments:argArrayOrNil
    "as a courtesy to the smalltalker, try to map methods"

    |args numArgs javaMethod sel m cls|

    args := argArrayOrNil.
    numArgs := args size.
    sel := selector.
    cls := receiver class.

    javaMethod := JavaClass lookupMethod:sel numArgs:numArgs in: cls static:false.

    javaMethod notNil ifTrue:[
        args notNil ifTrue:[
            args := JavaClass 
                        convertArgsToJava:args 
                        asSpecifiedIn:(javaMethod argSignature)
                        numArgs:numArgs.
        ].
        javaMethod isWrapped ifTrue:[
            m := javaMethod originalMethod
        ] ifFalse:[
            m := javaMethod
        ].
    ].
    ^ m.
"/        retVal := javaMethod 
"/            valueWithReceiver:self 
"/            arguments:args
"/            selector:m selector 
"/            search:m javaClass
"/            sender:nil.
"/
"/        ^ JavaClass convertToSmalltalk:retVal type:(m returnType).

    "Created: / 25-02-2011 / 19:49:22 / kursjan <kursjan@fit.cvut.cz>"
!

lookupMethodForSelector:selector directedTo:initialSearchClass for:aReceiver withArguments:argArrayOrNil from:sendingContext
    "as a courtesy to the smalltalker, try to map methods"
    | m |
    self halt.
"/    m := self javaLookupMethodForSelector: selector for: aReceiver withArguments: argArrayOrNil.
"/    m ifNotNil: [ ^ m ] .
    "
            I am not sure, if we should invoke builtin lookup. It will search for the Smalltalk-like methods.
            For example, if you invoke #isNumber on java.lang.String 
                a) you should get 'doesNotUnderstand'
                b) the isNumber from Object is invoked (currently implemented)
    "
    self breakPoint: #libjava.
    ^ self smalltalkLookupMethodForSelector:selector directedTo:initialSearchClass for:aReceiver withArguments:argArrayOrNil from:sendingContext

    "Created: / 21-02-2011 / 13:38:55 / kursjan <kursjan@fit.cvut.cz>"
    "Modified: / 11-04-2011 / 20:19:50 / kursjan <kursjan@fit.cvut.cz>"
!

smalltalkLookupMethodForSelector:selector directedTo:initialSearchClass for:aReceiver withArguments:argArrayOrNil from:sendingContext
    ^ Lookup builtin lookupMethodForSelector:selector directedTo:initialSearchClass for:aReceiver withArguments:argArrayOrNil from:sendingContext.

    "Created: / 25-02-2011 / 19:46:54 / kursjan <kursjan@fit.cvut.cz>"
! !

!JavaLookup class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !

